// 002 u_c_cgi_log
// 01 jan 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

// -- the ASCII log
// -- no other dependency

(*$r+*)

unit u_c_cgi_log;
  interface

    type c_simple_log= class
                         public
                           m_file: File;
                           m_who: String;
                           m_count: Integer;
                           m_convert_non_printable: Boolean;

                           constructor create_simple_log(p_who, p_file_name: String); Virtual;

                           procedure write_line(p_text: String);

                           destructor Destroy; Override;
                       end;

    function f_c_global_log: c_simple_log;

    procedure open_log(p_log_name: String);
    procedure write_log(p_text: String);
    procedure close_log;

  implementation
    uses Windows, SysUtils
        // , FileCtrl // adds 280 K !!!
        , u_cgi_dir
        ;

    constructor c_simple_log.create_simple_log(p_who, p_file_name: String);
      var l_log_path: String;
      begin
        m_who:= p_who;

        l_log_path:= ExtractFilePath(p_file_name);

        if Not f_directory_exists(l_log_path)
          then f_force_directories(l_log_path);

        AssignFile(m_file, p_file_name);
        if not FileExists(p_file_name)
          then begin
              Rewrite(m_file, 1);
              Close(m_file);
            end;

        // -- the date
        write_line('=========');
      end; // create_simple_log

    procedure c_simple_log.write_line(p_text: String);
      var // l_length: Integer;
          l_pt_characters: ^Char;
          l_text: String;
          l_index: Integer;
      begin
        if Length(p_text)> 0
          then begin
              l_text:= p_text;
              if m_convert_non_printable
                then begin
                    for l_index:= 1 to Length(p_text) do
                      if p_text[l_index] in [#13, #10, ' '..#127]
                        then l_text:= l_text+ p_text[l_index]
                        else l_text:= l_text+ '.'+ IntToHex(Ord(p_text[l_index]), 2)+ '.';
                  end;

              l_text:= DateTimeToStr(Now)+ ' '+ m_who+ ' '+ IntToStr(m_count)+ ' '+ l_text;
              Inc(m_count);

              Reset(m_file, 1);
              Seek(m_file, FileSize(m_file));
              l_text:= l_text+ chr(13)+ chr(10);
              l_pt_characters:= Pointer(@ l_text[1]);

              BlockWrite(m_file, l_pt_characters^, Length(l_text));
              CloseFile(m_file);
            end;
      end; // write_line

    destructor c_simple_log.Destroy;
      begin
        Inherited Destroy;
      end; // Destroy

    // -- non-object log handling

    var g_c_simple_log: c_simple_log= Nil;

    function f_c_global_log: c_simple_log;
      begin
        Result:= g_c_simple_log;
      end; // f_c_global_log

    procedure open_log(p_log_name: String);
      begin
        if p_log_name<> ''
          then g_c_simple_log:= c_simple_log.create_simple_log('', p_log_name);
      end; // open_log

    procedure write_log(p_text: String);
      begin
        if Assigned(g_c_simple_log)
          then g_c_simple_log.write_line(p_text);
      end; // write_log

    procedure close_log;
      begin
        g_c_simple_log.Free;
        g_c_simple_log:= Nil;
      end; // close_log

    initialization
    finalization
      close_log;
    end. // u_c_simple_log






