// 002 u_cgi_strings
// 01 jan 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_cgi_strings;
  interface
    type t_string_5= String[5];
         t_string_6= String[6];
         t_string_8= String[8];
         t_string_19= String[19];

    const k_dos_accents= [Chr($85), Chr($83), Chr($87), Chr($82), Chr($8A), Chr($88),
              Chr($8C), Chr($93), Chr($97), Chr($96)];
          k_windows_accents= [Chr($E0), Chr($E2), Chr($E7), Chr($E9), Chr($E8), Chr($EA),
              Chr($EE), Chr($F4), Chr($F9), Chr($FB)];
          // k_windows_accents_string= '';

    function f_replace_character(Const pk_string: string; p_original, p_replacement: char): string;

    function f_ansi(p_oem: String): String;
      // -- CAUTION f_ansi not Idempotent
    function f_oem(p_ansi: String): String;
    procedure change_windows_character_to_dos(var pv_character: Char);
    procedure change_dos_character_to_windows(var pv_character: Char);
    procedure transliterate_string_to_dos(var pv_string: String);
    procedure transliterate_string_to_windows(var pv_string: String);

    function f_no_accents(const pk_string: String): String;
    function f_lower_case_no_dos_nor_windows_accents(const pk_string: String): String;

    function f_extract_string(const pk_string: String; p_start, p_end: Integer): String;
    function f_extract_integer(const pk_string: String; p_start, p_end: Integer): Integer;
    function f_copy_end(p_string, p_end_text: String): String;
    function f_without_end(const pk_string, pk_end: String): String;
    function f_end_is_equal_to(p_string, p_end_text: String): Boolean;
    function f_start_is_equal_to(p_string, p_start: String): Boolean;
    function f_remove_end_if_end_is_equal_to(p_string, p_end: String): String;
    function f_remove_start_if_start_is_equal_to(p_string, p_start: String): String;
    function f_string_max(Const pk_string: String; p_max: Integer): String;

    // -- accounts
    function f_remove_trailing_0(const pk_account: String): String;
    function f_append_with_0(pk_account: String; p_size: Integer): String;

    function f_string_to_char(p_string: String; p_default: Char): Char;
      // because incompat btw some string param and char

    function f_pad_or_cut_string(const pk_string: String; p_size: Integer): String;

    function f_is_all_upper_case(const pk_string: String): Boolean;
    function f_common_string(pk_one, pk_two: String): String;

    function f_starting_space_count(p_string: String): Integer;

    function f_spaces(p_indente: Integer): String;

  implementation
    uses Windows, SysUtils
        // , u_display
        ;

    function f_spaces(p_indente: Integer): String;
      var l_indice: Integer;
      begin
        SetLength(Result, p_indente);
        for l_indice:= 1 to p_indente do
          Result[l_indice]:= ' ';
      end; // f_spaces

    // -- oem / ansi

    function f_ansi(p_oem: String): String;
      const k_buffer_max= 1024;
      var l_buffer: array[0..k_buffer_max] of Char;
          l_pt_buffer_z: pChar;
      begin
        if Length(p_oem)> k_buffer_max
          then begin
              // display_bug_stop('*** p_oem, too big');
              Result:= p_oem;
            end
          else begin
              l_pt_buffer_z:= @ l_buffer;
              // AnsiToOem(pChar(p_oem), l_pt_buffer_z);
              OemToAnsi(pChar(p_oem), l_pt_buffer_z);
              Result:= l_pt_buffer_z;
            end;
      end; // f_ansi

    function f_oem(p_ansi: String): String;
(*
      const k_buffer_max= 1024;
      var l_buffer: array[0..k_buffer_max] of Char;
          l_pt_buffer_z: pChar;
*)
      begin
        Result:= p_ansi;
        transliterate_string_to_dos(Result);
(*
        display_bug_stop('*** f_oem does not work (Perez)');
        if Length(p_ansi)> k_buffer_max
          then begin
              display_bug_stop('*** p_ansi, too big');
              Result:= p_ansi;
            end
          else begin
              l_pt_buffer_z:= @ l_buffer;
              AnsiToOem(pChar(p_ansi), l_pt_buffer_z);
              // OemToAnsi(pChar(p_ansi), l_pt_buffer_z);
              Result:= l_pt_buffer_z;
            end;
*)
      end; // f_oem

    procedure change_windows_character_to_dos(var pv_character: Char);
      begin
        case pv_character of
          Chr($E0) : pv_character:= Chr($85);
          Chr($E2) : pv_character:= Chr($83);

          Chr($E7) : pv_character:= Chr($87);

          Chr($E9) : pv_character:= Chr($82);
          Chr($E8) : pv_character:= Chr($8A);
          Chr($EA) : pv_character:= Chr($88);

          Chr($EE) : pv_character:= Chr($8C);

          Chr($F4) : pv_character:= Chr($93);

          Chr($F9) : pv_character:= Chr($97);
          Chr($FB) : pv_character:= Chr($96);
        end; // case
      end; // change_windows_character_to_dos

    procedure change_dos_character_to_windows(var pv_character: Char);
      begin
        case pv_character of
          Chr($85) : pv_character:= Chr($E0);
          Chr($83) : pv_character:= Chr($E2);

          Chr($87) : pv_character:= Chr($E7);

          Chr($82) : pv_character:= Chr($E9);
          Chr($8A) : pv_character:= Chr($E8);
          Chr($88) : pv_character:= Chr($EA);

          Chr($8C) : pv_character:= Chr($EE);

          Chr($93) : pv_character:= Chr($F4);

          Chr($97) : pv_character:= Chr($F9);
          Chr($96) : pv_character:= Chr($FB);
        end; // case
      end; // change_dos_character_to_windows

    procedure transliterate_string_to_dos(var pv_string: String);
      var l_index: Integer;
      begin
        for l_index:= 1 to Length(pv_string) do
          change_windows_character_to_dos(pv_string[l_index]);
      end; // transliterate_string_to_dos

    procedure transliterate_string_to_windows(var pv_string: String);
      var l_index: Integer;
      begin
        for l_index:= 1 to Length(pv_string) do
          change_dos_character_to_windows(pv_string[l_index]);
      end; // transliterate_string_to_windows

    // -- replace

    function f_replace_character(Const pk_string: string; p_original, p_replacement: char): string;
      var l_indice: Integer;
      begin
        Result:= pk_string;
        for l_indice:= 1 to Length(Result) do
          if Result[l_indice]= p_original
            then Result[l_indice]:= p_replacement;
      end; // f_replace_character

    function f_no_accents(const pk_string: String): String;
      var l_index: Integer;
      begin
        Result:= pk_string;
        For l_index:= 1 to Length(Result) do
          Case Result[l_index] of
            '' : Result[l_index]:= 'a';
            '' : Result[l_index]:= 'a';
            '' : Result[l_index]:= 'c';
            '' : Result[l_index]:= 'e';
            '' : Result[l_index]:= 'e';
            '' : Result[l_index]:= 'e';
            '' : Result[l_index]:= 'i';
            '' : Result[l_index]:= 'o';
            '' : Result[l_index]:= 'u';
            '' : Result[l_index]:= 'u';
          end; // case
      end; // f_no_accents

    function f_lower_case_no_dos_nor_windows_accents(const pk_string: String): String;
      var l_index: Integer;
      begin
        Result:= pk_string;
        For l_index:= 1 to Length(Result) do
          Case Result[l_index] of
            'A'..'Z' : Result[l_index]:= Chr(Ord(Result[l_index])+ 32);

            Chr($85), '' : Result[l_index]:= 'a';
            Chr($83), '' : Result[l_index]:= 'a';
            Chr($87), '' : Result[l_index]:= 'c';
            Chr($82), '' : Result[l_index]:= 'e';
            Chr($8A), '' : Result[l_index]:= 'e';
            Chr($88), '' : Result[l_index]:= 'e';
            Chr($8C), '' : Result[l_index]:= 'i';
            Chr($93), '' : Result[l_index]:= 'o';
            Chr($97), '' : Result[l_index]:= 'u';
            Chr($96), '' : Result[l_index]:= 'u';
          end; // case
      end; // f_lower_case_no_dos_nor_windows_accents

    function f_extract_string(const pk_string: String; p_start, p_end: Integer): String;
      var l_length: Integer;
      begin
        l_length:= p_end+ 1- p_start;
        SetLength(Result, l_length);
        Move(pk_string[p_start], Result[1], l_length);
      end; // f_extract_string

    function f_copy_end(p_string, p_end_text: String): String;
       // -- extract ".html" from "livres.html"
      var l_length_string, l_length_end: Integer;
      begin
        l_length_string:= Length(p_string);
        l_length_end:= Length(p_end_text);
        if (l_length_string> 0) and (l_length_end> 0)
          then Result:= Copy(p_string, l_length_string- l_length_end+ 1, l_length_end)
          else Result:= '';
      end; // f_copy_end

    function f_without_end(const pk_string, pk_end: String): String;
      var l_length_string, l_length_end: Integer;
      begin
        l_length_string:= Length(pk_string);
        l_length_end:= Length(pk_end);
        if (l_length_string>= l_length_end) and (l_length_end> 0)
          then Result:= Copy(pk_string, 1, l_length_string- l_length_end)
          else Result:= pk_string;
      end; // f_without_end

    function f_end_is_equal_to(p_string, p_end_text: String): Boolean;
      begin
        Result:= f_copy_end(p_string, p_end_text)= p_end_text;
      end; // f_end_is_equal_to

    function f_start_is_equal_to(p_string, p_start: String): Boolean;
      begin
        Result:= Copy(p_string, 1, Length(p_start))= p_start;
      end; // f_start_is_equal_to

    function f_remove_end_if_end_is_equal_to(p_string, p_end: String): String;
      begin
        if f_end_is_equal_to(p_string, p_end)
          then Result:= Copy(p_string, 1, Length(p_string)- Length(p_end))
          else Result:= p_string;
      end; // f_remove_end_if_end_is_equal_to

    function f_remove_start_if_start_is_equal_to(p_string, p_start: String): String;
      begin
        if f_start_is_equal_to(p_string, p_start)
          then Result:= Copy(p_string, Length(p_start)+ 1, Length(p_string)- Length(p_start))
          else Result:= p_string;
      end; // f_remove_start_if_start_is_equal_to

    function f_extract_integer(const pk_string: String; p_start, p_end: Integer): Integer;
      begin
        Result:= StrToInt(f_extract_string(pk_string, p_start, p_end));
      end; // f_extract_integer

    function f_string_max(Const pk_string: String; p_max: Integer): String;
      var l_size: Integer;
      begin
        l_size:= Length(pk_string);
        if l_size> p_max
          then Result:= Copy(pk_string, 1, p_max)
          else Result:= pk_string; // ds + f_spaces(p_max- l_size);
      end; // f_string_max

    function f_remove_trailing_0(const pk_account: String): String;
      var l_index: Integer;
      begin
        Result:= pk_account;
        l_index:= Length(Result);
        while (l_index>= 1) and (Result[l_index]= '0') do
        begin
          Delete(Result, l_index, 1);
          Dec(l_index);
        end;

        // if Result<> pk_account
        //   then display(pk_account+ ' -> '+ Result);
      end; // f_remove_trailing_0

    function f_append_with_0(pk_account: String; p_size: Integer): String;
      var l_index: Integer;
      begin
        Result:= pk_account;
        for l_index:= Length(pk_account)+ 1 to p_size do
          Result:= Result+ '0';
      end; // f_append_with_0

    function f_string_to_char(p_string: String; p_default: Char): Char;
      begin
        if p_string= ''
          then Result:= p_default
          else Result:= p_string[1];
      end; // f_string_to_char

    function f_pad_or_cut_string(const pk_string: String; p_size: Integer): String;
      var l_size: Integer;
      begin
        l_size:= Length(pk_string);
        if l_size> p_size
          then Result:= Copy(pk_string, 1, p_size)
          else
            if l_size< p_size
              then Result:= pk_string // ds + f_spaces(p_size- l_size)
              else Result:= pk_string;
      end; // f_pad_or_cut_string
      
    function f_is_all_upper_case(const pk_string: String): Boolean;
      var l_index: Integer;
      begin
        Result:= False;
        for l_index:= 1 to Length(pk_string) do
          if not (pk_string[l_index] in ['A'..'Z'])
            Then Exit;
        Result:= True;    
      end; // f_is_all_upper_case

    function f_common_string(pk_one, pk_two: String): String;
      var l_index: Integer;
      begin
        Result:= '';
        l_index:= 1;
        while (l_index<= Length(pk_one)) and (l_index<= Length(pk_two))
            and (pk_one[l_index]= pk_two[l_index]) do
        begin
          result:= Result+ pk_one[l_index];
          Inc(l_index);
        end;
      end; // f_commond_string

    function f_starting_space_count(p_string: String): Integer;
      var l_index: Integer;
      begin
        l_index:= 1;
        while (l_index<= Length(p_string)) and (p_string[l_index]= ' ') do
          Inc(l_index);
        Result:= l_index- 1;
      end; // f_starting_space_count

    end.

