// 002 u_c_cgi_html_result_page_builder
// 02 jan 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_cgi_html_result_page_builder;
  interface
    uses Classes
      , u_c_cgi_basic_object
      , u_c_cgi_log
      , u_c_cgi_result_page_list
      ;

    type c_html_result_page_builder= class(c_basic_object)
                                       // -- m_name: the request (for the error display)
                                       m_c_simple_log_ref: c_simple_log;
                                       m_c_html_page: tStringList;
                                       m_site_url: String;

                                       m_write_log_debug_search: Boolean;

                                       Constructor create_html_result_page_builder(p_name: String;
                                           p_site_url: String);

                                       procedure write_log_debug_search(p_text: String);

                                       procedure build_error_page(p_error_index, p_error_length: Integer;
                                           p_error_message: String);
                                       procedure build_the_result_page(p_c_result_page_list: c_result_page_list);

                                       Destructor Destroy; Override;
                                     end; // c_html_result_page_builder

  implementation
    uses SysUtils
      , u_cgi_strings // f_replace_character
      , u_cgi_strings_html // f_nbsp
      , u_cgi_helpers
      ;

    function f_red_string(p_string: String): String;
      begin
        Result:= '<FONT COLOR="#FF000">'+ p_string+ '</FONT>';
      end; // f_red_string

    function f_fat_string(p_string: String): String;
      begin
        Result:= '<B>'+ p_string+ '</B>';
      end; // f_fat_string

    // -- c_html_result_page_builder

    Constructor c_html_result_page_builder.create_html_result_page_builder(p_name: String;
        p_site_url: String);
      begin
        Inherited create_basic_object(p_name);

        m_site_url:= p_site_url;

        write_log('  ok create_build');
      end; // create_html_result_page_builder

    procedure c_html_result_page_builder.write_log_debug_search(p_text: String);
      begin
        if m_write_log_debug_search
          then write_log(p_text);
      end; // write_to_log

    procedure c_html_result_page_builder.build_error_page(p_error_index, p_error_length: Integer;
        p_error_message: String);
      var l_error_string: String;
          l_start, l_error, l_end: String;
      begin
        m_c_html_page:= tStringList.Create;

        l_start:= Copy(m_name, 1, p_error_index- 1);
        l_error:= Copy(m_name, p_error_index, p_error_length);
        l_end:= Copy(m_name, p_error_index+ p_error_length,
            Length(m_name)+ 1- p_error_index- p_error_length);
        if l_error= ''
          then l_error:= '?';
        // display(l_start+ '|'+ l_error+ '|'+ l_end+ '|');

        l_error_string:= l_start
            + '<FONT COLOR="#FF0000"><B>'
            + ' *** '+ l_error+ ' *** '
            + '</B></FONT>'
            + l_end;

        with m_c_html_page do
        begin
          Add('<HTML>');
          Add('  <HEAD>');
          Add('    <TITLE>');
          Add('    </TITLE>');
          Add('  </HEAD>');
          Add('  <BODY>');
          Add('    <H2><CENTER><FONT COLOR="#FF0000">'+ m_name
              + '</FONT><BR>'
              + '</CENTER></H2>');

          Add('    Erreur dans la question:<BR><BR>');
          Add('    '+ f_nbsp(4)+ l_error_string+ '<BR><BR>');
          Add('    '+ f_red_string(p_error_message)+ '&nbsp;.&nbsp;');
          Add('    Veuillez corriger l''erreur');

          Add('  </BODY>');
          Add('</HTML>');
        end; // with m_c_html_page
      end; // build_error_page

    procedure c_html_result_page_builder.build_the_result_page(p_c_result_page_list: c_result_page_list);

      procedure add_file_name(p_page_index: Integer; p_c_result_page: c_result_page);
        var l_file_index: String;
            l_path, l_site_root_path: String;
            l_file_name_only: String;
            l_anchor: String;
            l_file_date_and_size: String;
        begin
          with p_c_result_page do
          begin
            // -- if on a local path, keep the search path
            // -- if on server site, replace the site root with the url

            if m_site_url= ''
              then l_path:= m_path
              else begin
                  // -- remove "g:\inetpub\" etc
                  l_site_root_path:= LowerCase(f_cgi_exe_path);
                  // -- remove the ending "Script\"
                  l_site_root_path:= f_remove_end_if_end_is_equal_to(l_site_root_path, 'scripts\');
                  // write_log('root '+ l_site_root_path+ '<');
                  // write_log('m_path '+ m_path+ '<');

                  // -- remove this part from the search path
                  l_path:= m_path;
                  Delete(l_path, 1, Length(l_site_root_path));
                  // -- prepend the site url
                  l_path:= m_site_url+ l_path;
                  l_path:= f_replace_character(l_path, '\', '/');
                  // write_log('l_path '+ l_path+ '<');
                end;

            l_file_index:= Format('%-3s - ', [IntToStr(p_page_index)]);

            l_file_name_only:= ChangeFileExt(m_file_name, '');
            write_log('   - '+ l_file_name_only);

            l_anchor:= '<A HREF="'+ l_path+ m_file_name+ '">'+ l_file_name_only+ '</A>';
            l_file_date_and_size:= '<BR>'+ f_nbsp(8)+  FormatDateTime('dd mmm yyyy', m_date_time)
                   + FormatFloat(' -  ###,###,##0', m_size/ 1000)+ ' K';

            m_c_html_page.Add('    '+ l_file_index
               + l_anchor
               + ' - '+ m_content
               + l_file_date_and_size
               + '<BR>');
          end; // with p_c_result_page
        end; // add_file_name

      procedure add_bottom_links;
        const k_home= '<A HREF="http://www.jcolibri.com/';
        begin
          with m_c_html_page do
          begin
            Add('    <HR>');
            Add('    <TABLE border=0 bgcolor="CCFFFF" width="100%">');
            Add('      <TR>');
            Add('        <TD>');
            Add('          Maj 10-05. &copy; J.Colibri 2005.&nbsp;<BR>');
            Add('          <FONT COLOR="FF0000">Retour:</FONT> &nbsp;&nbsp;');
            Add(k_home+ 'index.html" target="_top">Home</A> &nbsp;');
            Add(k_home+ 'articles/articles_frame.html" target="content">Articles</A> &nbsp;');
            Add(k_home+ 'stages/stages_frame.html" target="content">Stages</A> &nbsp;');
            Add(k_home+ 'livres/livres_frame.html" target="content">Livres</A> &nbsp;');
            Add(k_home+ 'pascalissime/pascalissime_frame.html" target="content">Pascalissime</A> &nbsp;');
            Add(k_home+ 'telecharger/telecharger_frame.html" target="_parent">Download</A>');
            Add('        </TD>');
            Add('      </TR>');
            Add('    </TABLE>');
          end; // with m_c_html_page
        end; // add_bottom_links

      var l_element_index: Integer;
          l_number_of_files: String;
          // l_elements_string: String;

      begin // build_result_page
        m_c_html_page:= tStringList.Create;

        with p_c_result_page_list do
          l_number_of_files:= '(trouv '+ IntToStr(f_result_page_count)+ ' sur '
              + IntToStr(m_total_page_count)+ ' pages)';

        with m_c_html_page do
        begin
          Add('<HTML>');
          Add('  <HEAD>');
          Add('    <TITLE>Rsultats</TITLE>');
          Add('  </HEAD>');
          Add('  <BODY>');
          Add('    <H2><CENTER><FONT COLOR="#FF0000">'+ m_name
              + '</FONT><BR>'
              + l_number_of_files+ '</CENTER></H2>');

          write_log('  count '+ IntToStr(p_c_result_page_list.f_result_page_count));
          with p_c_result_page_list do
            for l_element_index:= 0 to f_result_page_count- 1 do
              add_file_name(l_element_index, f_c_result_page(l_element_index));

          add_bottom_links;

          Add('  </BODY>');
          Add('</HTML>');
        end; // with m_c_html_page
      end; // build_the_result_page

    Destructor c_html_result_page_builder.Destroy;
      begin
        m_c_html_page.Free;

        Inherited;
      end; // Destroy

    begin // u_c_html_result_page_builder
    end. // u_c_html_result_page_builder


