// 002 u_c_cgi_result_page_list
// 01 jan 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

// -- todo: add delete

(*$r+*)

unit u_c_cgi_result_page_list;
  interface
    uses Classes, u_c_cgi_basic_object;

    type c_result_page= // one "result_page"
                        Class(c_basic_object)
                          // -- m_name: -
                          m_path, m_file_name: String;
                          m_size: Integer;
                          m_date: String;
                          m_date_time: tDateTime;
                          // m_title,
                          m_content: String;

                          Constructor create_result_page(p_name, p_path, p_file_name: String;
                              p_size: Integer; p_date_time: tDateTime;
                              p_content: String);
                          function f_display_result_page: String;
                          function f_c_self: c_result_page;
                          Destructor Destroy; Override;
                        end; // c_result_page

         c_result_page_list= // "result_page" list
                             Class(c_basic_object)
                               m_c_result_page_list: tStringList;

                               // -- other information to hand over to the result builder
                               m_total_page_count: Integer;

                               Constructor create_result_page_list(p_name: String);

                               function f_result_page_count: Integer;
                               function f_c_result_page(p_result_page_index: Integer): c_result_page;
                               function f_c_add_result_page(p_result_page_name, p_path, p_file_name: String;
                                  p_size: Integer; p_date_time: tDateTime;
                                  p_content: String): c_result_page;

                               Destructor Destroy; Override;
                             end; // c_result_page_list

  implementation
    uses SysUtils, u_cgi_display;

    // -- c_result_page

    Constructor c_result_page.create_result_page(p_name, p_path, p_file_name: String;
        p_size: Integer; p_date_time: tDateTime; p_content: String);
      begin
        Inherited create_basic_object(p_name);

        m_path:= p_path;
        m_file_name:= p_file_name;
        m_size:= p_size;
        m_date_time:= p_date_time;
        m_content:= p_content;
      end; // create_result_page

    function c_result_page.f_display_result_page: String;
      begin
        Result:= Format('%-10s ', [m_name]);
      end; // f_display_result_page

    function c_result_page.f_c_self: c_result_page;
      begin
        Result:= Self;
      end; // f_c_self

    Destructor c_result_page.Destroy;
      begin
        InHerited;
      end; // Destroy

    // -- c_result_page_list

    Constructor c_result_page_list.create_result_page_list(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_result_page_list:= tStringList.Create;
      end; // create_result_page_line

    function c_result_page_list.f_result_page_count: Integer;
      begin
        Result:= m_c_result_page_list.Count;
      end; // f_result_page_count

    function c_result_page_list.f_c_result_page(p_result_page_index: Integer): c_result_page;
      begin
        Result:= c_result_page(m_c_result_page_list.Objects[p_result_page_index]);
      end; //  f_c_result_page

    function c_result_page_list.f_c_add_result_page(p_result_page_name, p_path, p_file_name: String;
        p_size: Integer; p_date_time: tDateTime; p_content: String): c_result_page;
      begin
        Result:= c_result_page.create_result_page(p_result_page_name, p_path, p_file_name,
            p_size, p_date_time, p_content);
        m_c_result_page_list.AddObject(p_result_page_name, Result);
      end; // f_c_add_result_page

    Destructor c_result_page_list.Destroy;
      var l_result_page_index: Integer;
      begin
        for l_result_page_index:= 0 to f_result_page_count- 1 do
          f_c_result_page(l_result_page_index).Free;
        m_c_result_page_list.Free;

        Inherited;
      end; // Destroy

    begin // u_c_result_page_list
    end. // u_c_result_page_list
